unit main;

interface

// Remove the next line to enable gif support
{$DEFINE USEJPEG}

uses
  Windows, Messages, SysUtils, Classes, HTTPApp, shellApi, graphics, syncobjs,
  ImgList, Controls, inifiles, {$IFDEF USEJPEG}jpeg{$ELSE}gifimage{$ENDIF};

type
  TWebModule1 = class(TWebModule)
    procedure WebModule1RootAction(Sender: TObject; Request: TWebRequest;
      Response: TWebResponse; var Handled: Boolean);
  private
    { Private-Deklarationen}
  public
    { Public-Deklarationen}
  end;

var
   WebModule1: TWebModule1;

implementation

{$R *.DFM}

//------------------------------------------------------------------------------
// Webserver-Routines
//------------------------------------------------------------------------------

// Main function: convert file and stream it
procedure TWebModule1.WebModule1RootAction(Sender: TObject;
  Request: TWebRequest; Response: TWebResponse; var Handled: Boolean);
var
   MyIcon: TIcon;
   MyImage: {$IFDEF USEJPEG}TJPEGimage{$ELSE}TGIFimage{$ENDIF};
   {$IFDEF USEJPEG}MyBMP: TBitmap;{$ENDIF}
   MyStream: TMemoryStream;
   iconIdx: word;
   srcFile: string;
begin
   // Read Source File Name
   srcFile:=Request.QueryFields.Values['file'];
   // Exit if no source file is specified
   if (srcFile='') or (not fileexists(srcFile)) then begin
      // Send not found (404)
      Response.StatusCode:=404;
      Response.SendResponse;
   end else begin
      // Read Icon from File
      MyIcon := TIcon.Create;
      MyImage:={$IFDEF USEJPEG}TJPEGimage{$ELSE}TGIFimage{$ENDIF}.Create;
      MyStream:=TMemorystream.Create;
      try
         iconIdx:=0;
         MyIcon.Handle := ExtractAssociatedIcon(HInstance, pchar(srcFile), IconIdx);
         // Convert Icon2GIF or Icon2JPGviaBMP
         {$IFDEF USEJPEG}
         MyBMP:=TBitmap.create;
         with MyBMP do begin
            width:=32; height:=32;
            canvas.draw(0,0,myIcon);
         end;
         MyImage.assign(MyBmp);  //jpg
         {$ELSE}
         MyImage.assign(MyIcon); //gif
         {$ENDIF}
         // Send Stream
         MyImage.saveToStream(MyStream);
         MyStream.Position := 0;
         Response.ContentType := {$IFDEF USEJPEG}'image/jpeg'{$ELSE}'image/gif'{$ENDIF};
         Response.ContentStream := MyStream;
         Response.SendResponse;
      finally
         MyImage.Free;
         {$IFDEF USEJPEG}MyBMP.free;{$ENDIF}
         MyIcon.Free;
         Handled:=true;
      end;
   end;
end;

end.
